## libpano13 2.9.17+dfsg

=== CMakeLists.txt ===
## cmakelists.txt for libpano13 in a Hugin build environment.
##     03-04 Aug 2009 TKSharpless
##  Updated 16 Jan 2010 to add general Pannini projection
##
## For Windows, download just part of the panotools SVN tree:
## https://panotools.svn.sourceforge.net/svnroot/panotools/trunk/libpano
## into local directory libpano under the hugin SDK root.
## Then build in-place with CMake, and build INSTALL.  That
## will create a directory in the SDK root that the hugin
## CMake build scripts can use.
##    
## Builds libpano13 and selected panotools, by default without 
## support for the Java programs ptpicker and pteditor.  You
## can define HAVE_JAVA on the CMake command line; the Java
## header jni.h and its dependencies must then be in your
## include search path(this script does not find them).
##
## This script uses the Hugin CMake modules to find required
## image file format libraries, so it needs to know the name
## of the Hign source tree root.  By default that must be
## "../hugin" relative to the libpano root(that contains
## this file).  But you can set HUGIN_BASE_DIR to the path
## name of the Hugin root on the CMake command line.
##
## The parent directory of the Hugin root is one place where
## dependencies will be looked for.  On Windows that should
## be the root directory of the Hugin SDK, and the wxWidgets
## package will likely supply the dependencies.  Note:  you
## may need to edit the wxWidgets version number below.
##


# requires at least cmake 2.6, now
cmake_minimum_required(VERSION 2.6)

## Locate the hugin source root and its parent directory
IF(HUGIN_BASE_DIR)
  GET_FILENAME_COMPONENT(SOURCE_BASE_DIR ${HUGIN_BASE_DIR} PATH CACHE)
  set(CMAKE_MODULE_PATH ${HUGIN_BASE_DIR}/CMakeModules)
ELSE(HUGIN_BASE_DIR)
  GET_FILENAME_COMPONENT(SOURCE_BASE_DIR ${CMAKE_SOURCE_DIR} PATH CACHE)
  set(CMAKE_MODULE_PATH ${SOURCE_BASE_DIR}/hugin/CMakeModules)
ENDIF(HUGIN_BASE_DIR)

IF(WIN32)
  set(CMAKE_INSTALL_PREFIX "${SOURCE_BASE_DIR}/libpano13" CACHE PATH "Install prefix for hugin SDK")
ENDIF(WIN32)

include(CheckIncludeFiles)

##  global setup
project(libpano13)

##
## wxWidgets
##
#  This must come before FINDs for tiff, jpeg, png, zlib to enable
#  finding the wxWidgets distributions of those packages on Windows.
IF(WIN32)
  SET(wxWidgets_ROOT_DIR ${SOURCE_BASE_DIR}/wxWidgets-2.8.10)
  ADD_DEFINITIONS(-D__Win__)
  FIND_PACKAGE(wxWidgets REQUIRED)
  set(win_c "tools/compat_win32/getopt.c")
ENDIF(WIN32)


##
## Graphics libraries
##
# wxWidgets sub-packages will be used if native ones aren't found

FIND_PACKAGE(TIFF REQUIRED)
INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
FIND_PACKAGE(JPEG REQUIRED)
INCLUDE_DIRECTORIES(${JPEG_INCLUDE_DIR})
FIND_PACKAGE(PNG REQUIRED)
INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})

set(_common_libs ${TIFF_LIBRARIES} ${ZLIB_LIBRARIES} ${JPEG_LIBRARIES} ${PNG_LIBRARIES})

#
# Check build type and set options accordingly
#
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)
IF(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
  ADD_DEFINITIONS(-DDEBUG)
  IF(UNIX)
    ADD_DEFINITIONS(-Wall)
  ENDIF(UNIX)
ENDIF(${CMAKE_BUILD_TYPE} STREQUAL "Debug")

IF(UNIX)
  ADD_DEFINITIONS(-D__Ansi__)
ELSE(UNIX)
  IF(MSVC)
    # Stop MSVC8 from bitching about the C library
    ADD_DEFINITIONS(/D_CRT_SECURE_NO_DEPRECATE)
    # Stop MSVC9 from bitching about possibly invalid STL usage
    ADD_DEFINITIONS(/D_SCL_SECURE_NO_WARNINGS)
    # Stop MSVC9 from bitching about POSIX names without underscores
    ADD_DEFINITIONS(/D_CRT_NONSTDC_NO_DEPRECATE)
    # compile everything for the static C runtime
	FOREACH(TYPE C CXX)
		# makefiles use blank configuration
		FOREACH(CFG "_DEBUG" "_MINSIZEREL" "_RELEASE" "_RELWITHDEBINFO")
			#MESSAGE("Replacing CMAKE_${TYPE}_FLAGS${CFG}: ${CMAKE_${TYPE}_FLAGS${CFG}}")
			SET(NEW_FLAGS "${CMAKE_${TYPE}_FLAGS${CFG}}")
			# fix up static libc flags
			STRING(REPLACE "/MD" "/MT" NEW_FLAGS "${NEW_FLAGS}")
			# *FORCE* to override whats already placed into the cache
			SET(CMAKE_${TYPE}_FLAGS${CFG} "${NEW_FLAGS}" CACHE STRING
				"CMAKE_${TYPE}_FLAGS${CFG} (overwritten to ensure static build)" FORCE)
			#MESSAGE("New       CMAKE_${TYPE}_FLAGS${CFG}: ${CMAKE_${TYPE}_FLAGS${CFG}}")
		ENDFOREACH(CFG)
	ENDFOREACH(TYPE)
    # link only with the static C runtime !! THIS IS A MUST !!
	SET(NEW_FLAGS "${CMAKE_EXE_LINKER_FLAGS}")
	# ensure that the flags are not duplicaated on subsequent runs
	STRING(REPLACE " /NODEFAULTLIB:\"MSVCRT.lib\" /NODEFAULTLIB:\"MSVCRTd.lib\"" "" NEW_FLAGS "${NEW_FLAGS}")
	# note that flag names(NODEFAULTLIB) etc.) are case sensitive
    SET(CMAKE_EXE_LINKER_FLAGS
        "${NEW_FLAGS} /NODEFAULTLIB:\"MSVCRT.lib\" /NODEFAULTLIB:\"MSVCRTd.lib\""
       CACHE STRING "for MSVC" FORCE
)
  ENDIF(MSVC)
ENDIF(UNIX)

##
## Here is the part that builds libpano
##
if(HAVE_JAVA)
  set(java_h pteditor.h ptutils.h)
  set(java_c ptpicker.c pteditor.c)
else()
  set(java_c javastub.c)
endif(HAVE_JAVA)

set(pano13_install_hdr
  panorama.h
  filter.h
  version.h
  panotypes.h
  PTcommon.h
  pt_stdint.h
  file.h
  queryfeature.h
  pteditor.h
  ptutils.h)

set(pano13_hdr
	${java_h}
	${pano13_install_hdr}
	ColourBrightness.h
	f2c.h
	fftn.h
	rgbe.h
	sys_ansi.h
	sys_win.h
	ZComb.h
	PaniniGeneral.h
)

set(pano13_res
	pano13.rc
	pano13vc.def
)

set(pano13_src
	${java_c}
	${win_c}
	adjust.c
	bmp.c
	ColourBrightness.c
	correct.c
	fftn.c
	file.c
	filter.c
	fourier.c
	hdrfile.c
	jpeg.c
	jpegicc.c
	lmdif.c
	math.c
	metadata.c
	morpher.c
	multilayer.c
	optimize.c
	pan.c
	parser.c
	perspect.c
	png.c
	ppm.c
	PTcommon.c
	PTDialogs.c
	ptfeather.c
	ptstitch.c
	queryfeature.c
	remap.c
	resample.c
	rgbe.c
	seamer.c
	sys_ansi.c
	sys_common.c
	tiff.c
	Triangulate.c
	ZComb.c
	PaniniGeneral.c
)
# We have some header files at top source level now
include_directories(${CMAKE_SOURCE_DIR})

if(NOT WIN32)
  # Create and install shared library on non-windows
  add_library(pano13 SHARED ${pano13_hdr} ${pano13_res} ${pano13_src})
  target_link_libraries(pano13 ${_common_libs})
  set_target_properties(pano13 PROPERTIES VERSION "2.0.0" SOVERSION "2")
  install(TARGETS pano13 LIBRARY DESTINATION lib)
  set(_pano_target pano13)
else()
  set(_pano_target pano13a)
endif()

#create and install static library
add_library(pano13a STATIC ${pano13_hdr} ${pano13_res} ${pano13_src})
set_target_properties(pano13a PROPERTIES OUTPUT_NAME pano13)
install(TARGETS pano13a ARCHIVE DESTINATION lib)

install(FILES ${pano13_install_hdr} DESTINATION "include/pano13")

# install documentation expected by hugin install script
INSTALL(
  FILES
	AUTHORS
	gpl.txt
	README
  DESTINATION "include/pano13"
        )
INSTALL(
  FILES
        doc/Optimize.txt
        doc/PTblender.readme
        doc/PTmender.readme
        doc/stitch.txt
  DESTINATION "include/pano13/doc"
        )

set(TOP_SRC_DIR ${CMAKE_SOURCE_DIR})

add_subdirectory(man)
add_dependencies(${_pano_target} man)
add_subdirectory(tools)
add_dependencies(tools ${_pano_target})

macro(setstripped _varname _value)
  string(STRIP ${_value} _v)
  if(USE_POSIX_PACKAGING)
    string(TOLOWER ${_v} ${_varname})
  else()
    set(${_varname} ${_v})
  endif()
endmacro(setstripped)

file(STRINGS "${TOP_SRC_DIR}/configure.ac" _config_lines)
foreach(_c_l ${_config_lines})
  if(_c_l MATCHES "^AC_INIT\\(\\[\([^,]+\)\\], *\\[\([^,]+\)\\], *\([^,]+\)")
    setstripped(PACKAGE_BASE ${CMAKE_MATCH_1})
    setstripped(PACKAGE_VERSION ${CMAKE_MATCH_2})
    setstripped(PACKAGE_BUGREPORT ${CMAKE_MATCH_3})
    if(PACKAGE_VERSION MATCHES "^\([0-9]+\)\\.\([0-9]+\)\\.\([0-9]+\).*$")
      message(STATUS "found version = ${PACKAGE_VERSION}")
      set(PANO_MAJOR_VERSION ${CMAKE_MATCH_1})
      set(PANO_MINOR_VERSION ${CMAKE_MATCH_2})
      set(PANO_PATCH_VERSION ${CMAKE_MATCH_3})
    endif()
  endif()
endforeach(_c_l)

# set some variables which are used in libpano13.pc.in
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(libdir ${CMAKE_INSTALL_PREFIX}/lib)
set(includedir ${CMAKE_INSTALL_PREFIX}/include)
set(LIB_JPEG ${JPEG_LIBRARY})
set(LIB_TIFF ${TIFF_LIBRARY})
set(LIB_ZLIB ${ZLIB_LIBRARY})
set(LIB_PNG ${PNG_LIBRARY})
set(VERSION ${PACKAGE_VERSION})

configure_file("${TOP_SRC_DIR}/libpano13.pc.in" "${CMAKE_BINARY_DIR}/libpano13.pc" @ONLY)

install(FILES "${CMAKE_BINARY_DIR}/libpano13.pc" DESTINATION "lib/pkgconfig")

set(CPACK_PACKAGE_VERSION_MAJOR "${PANO_MAJOR_VERSION}")
set(CPACK_PACKAGE_VERSION_MINOR "${PANO_MINOR_VERSION}")
set(CPACK_PACKAGE_VERSION_PATCH "${PANO_PATCH_VERSION}")

# needed by rpm
set(CPACK_SET_DESTDIR "ON")

# the next ones are needed by deb
set(CPACK_PACKAGE_CONTACT "${PACKAGE_BUGREPORT}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "libpano13")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${TOP_SRC_DIR}/README")
set(CPACK_RESOURCE_FILE_LICENSE "${TOP_SRC_DIR}/gpl.txt")

# Find the revision number and use it as the release in rpm-package-build.
# This way we may omit the otherwise needed "--force" parameter when
# installing from that rpm package.
# ... Disabled for the moment, because configure.ac supplies a value
find_program(_svnversion svnversion)
message(STATUS "svnversion = ${_svnversion}")
if(NOT ${_svnversion} MATCHES "-NOTFOUND")
  execute_process(COMMAND ${_svnversion} WORKING_DIRECTORY "${TOP_SRC_DIR}" OUTPUT_VARIABLE CPACK_RPM_PACKAGE_RELEASE OUTPUT_STRIP_TRAILING_WHITESPACE)
  # We use this value also to set the package-patch-value
  if(CPACK_RPM_PACKAGE_RELEASE MATCHES "^\([0-9]+\)")
    #set(CPACK_PACKAGE_VERSION_PATCH ${CMAKE_MATCH_1})
  endif()
endif()

set(CPACK_SOURCE_PACKAGE_FILE_NAME "libpano13-${PACKAGE_VERSION}")

include(CPack)


enable_testing()
add_subdirectory(tests)

=== debian/changelog ===
libpano13 (2.9.17+dfsg-3) experimental; urgency=low

  * 21_ftbfsgnuhurd.diff: Fix FTBFS on GNU/hurd. 

 -- Andreas Metzler <ametzler@debian.org>  Tue, 26 Oct 2010 19:34:56 +0200

libpano13 (2.9.17+dfsg-2) experimental; urgency=low

  * 20_fixpowerc.diff: Fix endless loop on PowerPC of commandline utils (used
    in testsuite). Closes: #599092

 -- Andreas Metzler <ametzler@debian.org>  Thu, 07 Oct 2010 19:07:52 +0200

libpano13 (2.9.17+dfsg-1) experimental; urgency=low

  * New upstream version.
  * Reintroduce support for dropping files to debian/rules' get-orig-source
    target.
  * Drop Visual C++ files from tarball, use +dfsg versioning.
  * Change shlibs to the normal >= relation again, since this is a stable
    release.
  * Standards-Version: 3.9.1.
  * Strip down libpano13 package description. Closes: #594596

 -- Andreas Metzler <ametzler@debian.org>  Sat, 02 Oct 2010 08:59:48 +0200

libpano13 (2.9.17~beta2-1) experimental; urgency=low

  * New upstream version.
  * Drop 20_bumpsoname.diff.
  * Bump shlibs.
  * Switch to dpkg-source v3.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 18 Jul 2010 08:24:39 +0200

libpano13 (2.9.15~beta2-1) experimental; urgency=low

  * New upstream version.
  * Drop patches applied upstream:
    + 20_libpano13+kbsd.diff
    + 30_undo_soname.bump
  * 20_bumpsoname.diff: Bump soname, now that the ABI really has changed.
  * Change library packagename to match soname.
  * Tighten libpano13-2 shlibs file to exactly match upstream version while
    still preserving binNMU-ability. Upstream might break the ABI another time
    without wanting to change the soname again before 2.9.15 is finally
    released. This tight dependency should be removed after the final release.

 -- Andreas Metzler <ametzler@debian.org>  Thu, 17 Sep 2009 15:20:46 +0200

libpano13 (2.9.15~beta1-1) experimental; urgency=low

  * New upstream pre-release.
    + debian/patches/30_undo_soname.bump - Undo unnecessary soname change.
    + Bump shlibs. (Newly added function.)
    + Ship newly available pkgconfig file.
  * Run upstream testsuite. Since it requires tiffcmp add libtiff-tools to
    build-depends. The upstream tarball is incomplete, it is missing some
    reference files for the testsuite. Pull them from upstream SVN and add
    them to the (repackaged) tarball.

 -- Andreas Metzler <ametzler@debian.org>  Mon, 14 Sep 2009 10:29:22 +0200

libpano13 (2.9.14-2) unstable; urgency=low

  * Stop shipping la file in -dev package. (Squeeze release goal).
  * debian/patches/20_libpano13+kbsd.diff - Fix FTBFS on GNU/kFreeBSD. Patch
    by Cyril Brulebois. Closes: #543998

 -- Andreas Metzler <ametzler@debian.org>  Sat, 29 Aug 2009 14:36:20 +0200

libpano13 (2.9.14-1) unstable; urgency=low

  * Upload to unstable.
  * [Lintian] Fix typo in debian control: s/algorithmical/algorithmic/.
  * Standards-Version: 3.8.2, no changes required.
  * Improve on watchfile to handle rc and beta versions.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 09 Aug 2009 14:01:24 +0200

libpano13 (2.9.14~rc1-1) experimental; urgency=low

  * New upstream prerelease.
    + New soname due to ABI breakage (new member in public struct). Change
      package name of library package.
    + Does not contain non-free files PixMap.c PixMap.h, no need for .dfsg
      version anymore. Also does away with the need for a complex
      get-orig-source
      target.
    + debian/manpages/* now shipped in upstream-tarball. Adapt build-system
      accordingly.
  * [lintian] Add ${misc:Depends}.
  * Standards version 3.8.1.
    + [debian/control] Add Homepage field.
    + Add rudimentary debian/README.source, basically pointing to quilt
      documentation.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 03 May 2009 19:56:34 +0200

libpano13 (2.9.12.dfsg-2) unstable; urgency=low

  * Drop Java support altogether (Closes: #477884). While checking that
    bugreport, it appeared that “HasJava” is only used in a single source
    file, which happens to be commented out.
     - debian/control: Drop libgcj-dev from Build-Depends.
     - debian/rules: Turn “--with-java” into “--without-java”.
     - debian/rules: Not bumping shlibs since no symbols changed (as
       expected given the above explanation).
  * Update my mail address in Uploaders.

 -- Cyril Brulebois <kibi@debian.org>  Sat, 26 Apr 2008 12:29:49 +0200

libpano13 (2.9.12.dfsg-1) unstable; urgency=low

  * Initial release (Closes: #433261), based on libpano12/2.8.6-0.1.
  * Repack because of the license of PixMap.{c,h}. These files seem to be
    needed only on Mac anyway:
     - Add a get-orig-source target to debian/rules.
     - Add version mangling to debian/watch.
  * The following glitches have been forwarded upstream so that these
    files will get proper copyright and license statements in further
    releases:
     - Copyright years are missing for jpegicc.{c,h}.
     - Copyright and license are missing for f2c.h. This file is available
       in the libf2c2 source package, and its copyright file has been used
       to complete this one.
     - Copyright and license are missing for rgbe.{c,h}. These files are
       available in the enblend source package, and its copyright file has
       been used to complete this one. The copyright by Bruce Walter is
       the original copyright notice, these files are now public domain.
  * Move from libpano12 to libpano13:
     - Update debian/copyright.
     - Update debian/watch, get rid of “debian uupdate”.
     - Update package names in debian/control, and clear the following
       fields: Provides, Conflicts, Replaces.
     - Add  “Conflicts: libpano12-bin” and “Replaces: libpano12-bin” to
       libpano13-bin.
     - Rename debian/libpano12* into debian/libpano13*.
     - Update debian/libpano13-bin.install:
        - Rename pano12info into panoinfo.
        - Rename PTOptimizer into PToptimizer.
     - Update debian/libpano13-bin.manpages accordingly.
     - Rename the manpages accordingly.


=== debian/control ===
Source: libpano13
Section: libs
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Cyril Brulebois <kibi@debian.org>, Florent Bayle <fbayle@bigfoot.com>, Andreas Metzler <ametzler@debian.org>
Build-Depends: debhelper (>= 5), cdbs, libpng12-dev, libjpeg62-dev, libtiff4-dev, autotools-dev, chrpath, libtiff-tools
Standards-Version: 3.9.1
Vcs-Browser: http://git.debian.org/?p=pkg-phototools/libpano.git
Vcs-Git: git://git.debian.org/git/pkg-phototools/libpano.git
Homepage: http://panotools.sourceforge.net/

Package: libpano13-dev
Section: libdevel
Architecture: any
Depends: libpano13-2 (= ${binary:Version}), ${misc:Depends}
Description: panorama tools library development files
 This package contains the panoramatools library. It provides basic
 algorithmic tools to generate, edit and transform many kinds of
 panoramic images.
 .
 This package holds static libraries and headers needed by developers
 who wish to use libpano13 in their programs.

Package: libpano13-2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libpano13-bin
Description: panorama tools library
 This package contains the panoramatools library. It provides basic
 algorithmic tools to generate, edit and transform many kinds of
 panoramic images.

Package: libpano13-bin
Section: graphics
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libpano12-bin
Replaces: libpano12-bin
Description: panorama tools utilities
 This package contains the following tools, all part of the Panorama Tools
 library, and supposed to make it easy to work with panoramic images:
  * panoinfo    - List details about the libpano13 library
  * PTblender   - Colour and brightness correction of panoramas
  * PTcrop      - Crop TIFF images
  * PTinfo      - Display information about a panotools-generated image
  * PTmasker    - Compute stitching masks
  * PTmender    - Replacement for PTStitcher
  * PToptimizer - Wrapper around control point optimization routines
  * PTroller    - Merge several images into a single one
  * PTtiff2psd  - Convert a set of TIFF files into a Photoshop PSD file
  * PTtiffdump  - Compare two TIFF images
  * PTuncrop    - Uncrop TIFF images

=== debian/rules ===
#!/usr/bin/make -f

# We don't use tarball.mk but there's a .tgz in the way
DEB_TARBALL=

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk


# For the repack: package name, mangled upstream version, non-free files
PACKAGE=libpano13
VERSION=$(shell dpkg-parsechangelog | perl -ne 'print "$$1\n" if (/^Version: (.*?)(?:\+dfsg)?\-.*?$$/)')


# --{list,fail}-missing don't make sense when dh_install is called for each
# package rather than once for all. See the hook below, only used to check
# the list of installed files. This is cdbs's #461368.
DEB_DH_INSTALL_ARGS=--autodest --sourcedir=debian/tmp

# What to pass to ./configure
DEB_CONFIGURE_EXTRA_FLAGS= \
	--prefix=/usr \
	--enable-shared \
	--enable-static \
	--with-jpeg \
	--with-png  \
	--with-tiff \
	--with-zlib \
	--without-java

# Could be merged into the former, but cleaner this way
DEB_CONFIGURE_SCRIPT_ENV += \
	LDFLAGS="-Wl,-z,defs -Wl,--as-needed" \
	LIBS="-lm"

DEB_DH_MAKESHLIBS_ARGS_libpano13-2 := -V 'libpano13-2 (>=2.9.17+dfsg-0)'
DEB_MAKE_CHECK_TARGET = check


# Between "make install" and "dh_*" calls
common-install-arch::
	# Clear the rpath set on some architectures (e.g. amd64)
	chrpath -d $(CURDIR)/debian/tmp/usr/bin/*
	chrpath -d $(CURDIR)/debian/tmp/usr/lib/*.so

	rm -f $(CURDIR)/debian/tmp/usr/lib/*.la

	# Check the list of installed files, see the comment above the
	# DEB_DH_INSTALL_ARGS declaration
	dh_install --fail-missing $(DEB_DH_INSTALL_ARGS)

# Build the DFSG-free source tarball
get-orig-source:
	# Download
	uscan --force-download --rename

	# Extract and prune non-free files
	tar xfz ../$(PACKAGE)_$(VERSION).orig.tar.gz
	find $(PACKAGE)-$(VERSION) \( -name '*.rc' -or -name '*.vcproj' \
		-or -name '*.sln' -or -name '*.vsprops' \) -type f -delete

	# Rename, repack and clean
	mv $(PACKAGE)-$(VERSION) $(PACKAGE)-$(VERSION).orig
	tar cfz ../$(PACKAGE)_$(VERSION)+dfsg.orig.tar.gz $(PACKAGE)-$(VERSION).orig
	rm -rf $(PACKAGE)-$(VERSION).orig

## libpano13 2.9.18%2Bdfsg

=== man/CMakeLists.txt ===
# This file is part of libpano13, the hugin build environment.
# Licence details can be found in the file gpl.txt.
#
# Copyright (c) 2009 Kornel Benko, <Kornel.Benko@berlin.de>
#

project(man)

file(GLOB_RECURSE manuals RELATIVE "${TOP_SRC_DIR}/man" "${TOP_SRC_DIR}/man/*.1")

macro(add_manual _mansrc)
  get_filename_component(_mandest ${_mansrc} NAME_WE)
  SET(_created_manual "${CMAKE_CURRENT_BINARY_DIR}/${_mandest}.1")
  configure_file("${TOP_SRC_DIR}/man/${_mansrc}" ${_created_manual} @ONLY)
  SET_SOURCE_FILES_PROPERTIES(${_created_manual} GENERATED)
  LIST(APPEND _manuals ${_created_manual})
endmacro(add_manual)

set(_manuals)
foreach(_m ${manuals})
  # this is not needed now, but maybe we will later
  # adapt data like version or date into the manuals
  add_manual(${_m})
endforeach(_m)

add_custom_target(man ALL DEPENDS ${_manuals})

install(FILES ${_manuals} DESTINATION "share/man/man1")

=== tests/CMakeLists.txt ===
# This file is part of libpano13, the hugin build environment.
# Licence details can be found in the file gpl.txt.
#
# Copyright (c) 2009 Kornel Benko, <Kornel.Benko@berlin.de>
#

project(test)

macro(prepare_test _testname _prjname _imagemask)
  file(GLOB images  RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}/${_imagemask}")
  file(GLOB references  RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}/reference/*")
  set(_depends)
  foreach(_i ${images} ${references})
    if(NOT IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/${_i}")
      add_custom_command(
        OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${_i}"
        COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_SOURCE_DIR}/${_i}" "${CMAKE_CURRENT_BINARY_DIR}/${_i}"
        DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${_i}")
      SET_SOURCE_FILES_PROPERTIES("${CMAKE_CURRENT_BINARY_DIR}/${_i}" GENERATED)
      list(APPEND _depends "${CMAKE_CURRENT_BINARY_DIR}/${_i}")
    endif()
  endforeach(_i)
  add_custom_target(${_prjname} ALL DEPENDS ${_depends})

  add_test(${_testname} ${PERL_EXECUTABLE} "${TOP_SRC_DIR}/tests/panoAutomateTest.pl" "${CMAKE_CURRENT_SOURCE_DIR}/simple.txt")
  add_dependencies(${_prjname} tools)
endmacro()

find_package(Perl)
if(PERL_FOUND)
    add_subdirectory(simpleStitch)
    add_subdirectory(simpleTiff16)
endif()

=== tests/simpleTiff16/CMakeLists.txt ===
# This file is part of libpano13, the hugin build environment.
# Licence details can be found in the file gpl.txt.
#
# Copyright (c) 2009 Kornel Benko, <Kornel.Benko@berlin.de>
#

project(test2)

prepare_test(simpleTiff16 test2 "*.TIF")

## libpano13 2.9.18+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -177,6 +177,7 @@
 	bmp.c
 	ColourBrightness.c
 	correct.c
+        dump.c
 	fftn.c
 	file.c
 	filter.c

=== tools/CMakeLists.txt ===
# This file is part of libpano13, the hugin build environment.
# Licence details can be found in the file gpl.txt.
#
# Copyright (c) 2009 Kornel Benko, <Kornel.Benko@berlin.de>
#

project(tools)

set(commands PTtiff2psd PTtiffdump PTcrop PTblender
    PTroller PTuncrop PToptimizer PTmender PTinfo PTmasker)
if (HAVE_JAVA)
  # this one depends on java (uses writeProject() from ptpicker)
  list(APPEND commands PTAInterpolate)
endif()

# panoinfo needs windows.h

if(WIN32)
  list(APPEND commands panoinfo)
endif()

include_directories(${TOP_SRC_DIR})

foreach(_cmd ${commands})
  add_executable(${_cmd} ${_cmd}.c)
  target_link_libraries(${_cmd} ${_pano_target} ${_common_libs})
  install(TARGETS ${_cmd} DESTINATION bin CONFIGURATIONS Release RelWithDebInfo MinSizeRel)
endforeach(_cmd)

add_custom_target(tools DEPENDS ${commands})

=== tests/simpleStitch/CMakeLists.txt ===
# This file is part of libpano13, the hugin build environment.
# Licence details can be found in the file gpl.txt.
#
# Copyright (c) 2009 Kornel Benko, <Kornel.Benko@berlin.de>
#

project(test1)

prepare_test(simpleStitch test1 "*.jpg")

=== debian/changelog ===
libpano13 (2.9.18+dfsg-6ubuntu2) trusty; urgency=medium

  * Use dh-autoreconf instead of autotools-dev to also fix FTBFS on ppc64el by
    getting new libtool macros (still updates config.{sub,guess}).

 -- Logan Rosen <logan@ubuntu.com>  Thu, 26 Dec 2013 18:16:38 -0500

libpano13 (2.9.18+dfsg-6ubuntu1) saucy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/control: Build-depend on libtiff-dev rather than libtiff4-dev.

 -- Logan Rosen <logan@ubuntu.com>  Mon, 13 May 2013 00:54:43 -0400

libpano13 (2.9.18+dfsg-6) unstable; urgency=low

  * Switch from cdbs to dh (v9). We now append to default LDFLAGS instead of
    overriding them.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 12 May 2013 15:34:03 +0200

libpano13 (2.9.18+dfsg-5) unstable; urgency=low

  * Source upload with no changes to fix multi-arch co-installability broken
    by binNMUs.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 28 Apr 2013 08:55:24 +0200

libpano13 (2.9.18+dfsg-4ubuntu1) quantal; urgency=low

  * Build-depend on libtiff-dev rather than libtiff4-dev.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 04 Sep 2012 14:16:13 +0100

libpano13 (2.9.18+dfsg-4) unstable; urgency=low

  * Convert to multi-arch.
    + configure with --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH), update
      chrpath invocation and debian/*.install accordingly.
    + Bump cdbs Build-Depends to 0.4.93 (required for expanding
      $(DEB_HOST_MULTIARCH)).
    + Bump debhelper b-d to 8.1.3 (for ${misc:Pre-Depends}).
    + Runtime library is Multi-Arch: same and has Pre-Depends:
      ${misc:Pre-Depends}, -bin (helper binaries) is 
      Multi-Arch: foreign. -dev is unchanged.
    + [lintian] Drop section setting from libpano13-2 package stanza.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 05 Feb 2012 11:18:42 +0100

libpano13 (2.9.18+dfsg-3) unstable; urgency=low

  * Build-Depend on libjpeg-dev instead of libjpeg62-dev. Closes: #634142

 -- Andreas Metzler <ametzler@debian.org>  Sun, 17 Jul 2011 14:16:50 +0200

libpano13 (2.9.18+dfsg-2) unstable; urgency=low

  * libpano13-2 now Breaks/Replaces: libpano13-1 (>= 2.9.15~beta2-1). This
    fixes cross-upgrades from the (slightly broken) packages in hugin PPA.
    (LP: #761760)

 -- Andreas Metzler <ametzler@debian.org>  Sun, 22 May 2011 14:46:00 +0200

libpano13 (2.9.18+dfsg-1) unstable; urgency=low

  * New upstream version, identical to 2.9.18~rc2.
  * Drop CFLAGS += -Wall again, it is set by default.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 08 May 2011 14:17:45 +0200

libpano13 (2.9.18~rc2+dfsg-2) experimental; urgency=low

  * 20_initfilenameargs.diff Fix sporadic ftbfs.
    https://bugs.launchpad.net/panotools/+bug/734867

 -- Andreas Metzler <ametzler@debian.org>  Sat, 19 Mar 2011 14:34:57 +0100

libpano13 (2.9.18~rc2+dfsg-1) experimental; urgency=low

  * New upstream version. 

 -- Andreas Metzler <ametzler@debian.org>  Mon, 07 Mar 2011 19:09:57 +0100

libpano13 (2.9.18~rc1+dfsg-1) experimental; urgency=low

  * New upstream version.
  * Update 10_workaround_libtool_link_as_needed_bug for libtool 2.2.6b.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 06 Mar 2011 10:17:13 +0100

libpano13 (2.9.18~beta1+dfsg-1) experimental; urgency=low

  * New upstream version.
  * Drop patches included uptream. (20_fixpowerc.diff 21_ftbfsgnuhurd.diff)
  * Set CFLAGS += -Wall, the latest combination of cdbs + dpkg-dev does not
    seem to set it by default.
  * Bump shlibs.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 19 Feb 2011 16:04:50 +0100

libpano13 (2.9.17+dfsg-4) unstable; urgency=low

  * Remove Florent Bayle from Uploaders. Thank you for your work.
    Closes: #554063
  * Also drop Cyril Brulebois from Uploaders. Thank you very much for your
    efforts.
  * Use debhelper compatibility level 7.
  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 06 Feb 2011 18:24:30 +0100

libpano13 (2.9.14-3) unstable; urgency=medium

  * 20_fixpowerc.diff: Fix endless loop of commandline utils on PowerPC (used
    in testsuite). Closes: #599092

 -- Andreas Metzler <ametzler@debian.org>  Thu, 07 Oct 2010 19:35:23 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,12 @@
 Source: libpano13
 Section: libs
 Priority: optional
-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
-Uploaders: Cyril Brulebois <kibi@debian.org>, Florent Bayle <fbayle@bigfoot.com>, Andreas Metzler <ametzler@debian.org>
-Build-Depends: debhelper (>= 5), cdbs, libpng12-dev, libjpeg62-dev, libtiff4-dev, autotools-dev, chrpath, libtiff-tools
-Standards-Version: 3.9.1
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
+Uploaders: Andreas Metzler <ametzler@debian.org>
+Build-Depends: debhelper (>= 9), libpng12-dev,
+  libjpeg-dev, libtiff-dev, dh-autoreconf, chrpath, libtiff-tools
+Standards-Version: 3.9.4
 Vcs-Browser: http://git.debian.org/?p=pkg-phototools/libpano.git
 Vcs-Git: git://git.debian.org/git/pkg-phototools/libpano.git
 Homepage: http://panotools.sourceforge.net/
@@ -22,10 +24,14 @@
  who wish to use libpano13 in their programs.
 
 Package: libpano13-2
-Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: ${misc:Pre-Depends}
 Suggests: libpano13-bin
+# Workaround for breakage in hugin PPA
+Breaks: libpano13-1 (>= 2.9.15~beta2-1)
+Replaces: libpano13-1 (>= 2.9.15~beta2-1)
+Multi-Arch: same
 Description: panorama tools library
  This package contains the panoramatools library. It provides basic
  algorithmic tools to generate, edit and transform many kinds of
@@ -37,6 +43,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: libpano12-bin
 Replaces: libpano12-bin
+Multi-Arch: foreign
 Description: panorama tools utilities
  This package contains the following tools, all part of the Panorama Tools
  library, and supposed to make it easy to work with panoramic images:

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CFLAGS_MAINT_APPEND := -Wall
export DEB_CXXFLAGS_MAINT_APPEND := -Wall
export DEB_LDFLAGS_MAINT_APPEND := -Wl,-z,defs -Wl,--as-needed

# For the repack: package name, mangled upstream version, non-free files
PACKAGE := libpano13
VERSION := $(shell dpkg-parsechangelog | perl -ne 'print "$$1\n" if (/^Version: (.*?)(?:\+dfsg)?\-.*?$$/)')


override_dh_auto_configure:
	dh_auto_configure --verbose -- \
		--enable-shared --enable-static \
		--with-jpeg --with-png --with-tiff \
		--with-zlib --without-java LIBS="-lm"

override_dh_makeshlibs:
	dh_makeshlibs -V 'libpano13-2 (>=2.9.18)'

override_dh_auto_install:
	dh_auto_install --verbose
	# Clear the rpath set on some architectures (e.g. amd64)
	chrpath -d $(CURDIR)/debian/tmp/usr/bin/* \
		$(CURDIR)/debian/tmp/usr/lib/*/*.so
	rm -vf $(CURDIR)/debian/tmp/usr/lib/*/*.la

override_dh_install:
	dh_install --fail-missing

# Build the DFSG-free source tarball
get-orig-source:
	# Download
	uscan --force-download --rename

	# Extract and prune non-free files
	tar xfz ../$(PACKAGE)_$(VERSION).orig.tar.gz
	find $(PACKAGE)-$(VERSION) \( -name '*.rc' -or -name '*.vcproj' \
		-or -name '*.sln' -or -name '*.vsprops' \) -type f -delete

	# Rename, repack and clean
	mv $(PACKAGE)-$(VERSION) $(PACKAGE)-$(VERSION).orig
	tar cfz ../$(PACKAGE)_$(VERSION)+dfsg.orig.tar.gz $(PACKAGE)-$(VERSION).orig
	rm -rf $(PACKAGE)-$(VERSION).orig

%:
	dh $@ --with autoreconf

=== debian/watch ===
version=3

opts=dversionmangle=s/\+dfsg$//,\
uversionmangle=s/_rc/~rc/;s/_beta/~beta/ \
http://sf.net/panotools/libpano13-(.*)\.tar\.gz

## libpano13 2.9.19%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -4,17 +4,17 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Andreas Metzler <ametzler@debian.org>
-Build-Depends: debhelper (>= 9), libpng12-dev,
-  libjpeg-dev, libtiff-dev, dh-autoreconf, chrpath, libtiff-tools
-Standards-Version: 3.9.4
-Vcs-Browser: http://git.debian.org/?p=pkg-phototools/libpano.git
-Vcs-Git: git://git.debian.org/git/pkg-phototools/libpano.git
+Build-Depends: debhelper (>= 10), libpng-dev,
+  libjpeg-dev, libtiff-dev, chrpath, libtiff-tools
+Standards-Version: 4.1.0
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-phototools/libpano.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-phototools/libpano.git -b libpano13/unstable
 Homepage: http://panotools.sourceforge.net/
 
 Package: libpano13-dev
 Section: libdevel
 Architecture: any
-Depends: libpano13-2 (= ${binary:Version}), ${misc:Depends}
+Depends: libpano13-3 (= ${binary:Version}), ${misc:Depends}
 Description: panorama tools library development files
  This package contains the panoramatools library. It provides basic
  algorithmic tools to generate, edit and transform many kinds of
@@ -23,14 +23,11 @@
  This package holds static libraries and headers needed by developers
  who wish to use libpano13 in their programs.
 
-Package: libpano13-2
+Package: libpano13-3
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Suggests: libpano13-bin
-# Workaround for breakage in hugin PPA
-Breaks: libpano13-1 (>= 2.9.15~beta2-1)
-Replaces: libpano13-1 (>= 2.9.15~beta2-1)
 Multi-Arch: same
 Description: panorama tools library
  This package contains the panoramatools library. It provides basic
